unit frmmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SDL_gradfl, StdCtrls, SDL_scale, Buttons;

type
  TForm1 = class(TForm)
    Scale1: TScale;
    Scale2: TScale;
    SBarMeterValue: TScrollBar;
    GradFill1: TGradFill;
    Scale3: TScale;
    Scale4: TScale;
    BButExit: TBitBtn;
    SBarHigh: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure SBarMeterValueChange(Sender: TObject);
    procedure Scale2AfterScaleRendered(Sender: TObject; Canvas: TCanvas);
    procedure Scale3AfterScaleRendered(Sender: TObject; Canvas: TCanvas);
    procedure Scale4BeforeScaleRendered(Sender: TObject; Canvas: TCanvas);
    procedure BButExitClick(Sender: TObject);
    procedure SBarHighChange(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

(******************************************************************************)
procedure TForm1.Scale2AfterScaleRendered(Sender: TObject; Canvas: TCanvas);
(******************************************************************************)

var
  x, v : integer;

begin
Canvas.Brush.Style := bsSolid;
Canvas.Brush.Color := clRed;
v := SBarMeterValue.Position;
if v < Scale2.RangeLow then
  v := round(Scale2.RangeLow);
if v > Scale2.RangeHigh then
  v := round(Scale2.RangeHigh);
x := Scale2.ConvertToPixelCoords (v);
Canvas.Rectangle(x-2, 2, x+2, 14);
end;


(******************************************************************************)
procedure TForm1.SBarMeterValueChange(Sender: TObject);
(******************************************************************************)

begin
Scale2.Refresh;
Scale3.Refresh;
Scale4.Refresh;
end;


(******************************************************************************)
procedure TForm1.Scale3AfterScaleRendered(Sender: TObject; Canvas: TCanvas);
(******************************************************************************)

var
  x,y : integer;
  v   : integer;

begin
Canvas.Brush.Style := bsSolid;
Canvas.Brush.Color := clLime;
v := SBarMeterValue.Position;
if v < Scale3.RangeLow then
  v := round(Scale3.RangeLow);
if v > Scale3.RangeHigh then
  v := round(Scale3.RangeHigh);
x := Scale3.Width-Scale3.MarginRight;
y := Scale3.ConvertToPixelCoords (v);
Canvas.Polygon ([Point(x, y), Point(x+14, y+4), Point(x+14, y-4)]);
end;

(******************************************************************************)
procedure TForm1.Scale4BeforeScaleRendered(Sender: TObject; Canvas: TCanvas);
(******************************************************************************)

var
  y, y0 : integer;
  v     : integer;

begin
Canvas.Brush.Style := bsSolid;
if SBarMeterValue.Position < 0
  then begin
       Canvas.Brush.Color := clBlue;
       Canvas.Pen.Color := clBlue;
       end
  else begin
       Canvas.Brush.Color := clRed;
       Canvas.Pen.Color := clRed;
       end;
y0 := Scale4.ConvertToPixelCoords (0);
v := SBarMeterValue.Position;
if v < Scale4.RangeLow then
  v := round(Scale4.RangeLow);
if v > Scale4.RangeHigh then
  v := round(Scale4.RangeHigh);
y := Scale4.ConvertToPixelCoords (v);
Canvas.Rectangle (Scale4.Width-Scale4.MarginRight-5, y,
                  Scale4.Width-Scale4.MarginRight+8, y0);
end;

(******************************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(******************************************************************************)

begin
close;
end;

(******************************************************************************)
procedure TForm1.SBarHighChange(Sender: TObject);
(******************************************************************************)

begin
Scale1.RangeHigh := SBarHigh.Position;
Scale2.RangeHigh := SBarHigh.Position;
end;

end.
